# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from robotnik_msgs/SafetyModuleStatus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import robotnik_msgs.msg

class SafetyModuleStatus(genpy.Message):
  _md5sum = "d0be25fea94411eb8319fc07e8d9c9bc"
  _type = "robotnik_msgs/SafetyModuleStatus"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# robot mode
string AUTO=auto
string MANUAL=manual
string EMERGENCY=emergency

string robot_mode
robotnik_msgs/LaserStatus laser_status
bool is_charging

bool manual_release
bool bumper_override
================================================================================
MSG: robotnik_msgs/LaserStatus
robotnik_msgs/LaserMode mode
bool laser_ok
bool free_warning   
================================================================================
MSG: robotnik_msgs/LaserMode
string STANDARD=standard
string DOCKING=docking
string CART=cart

string mode"""
  # Pseudo-constants
  AUTO = 'auto'
  MANUAL = 'manual'
  EMERGENCY = 'emergency'

  __slots__ = ['robot_mode','laser_status','is_charging','manual_release','bumper_override']
  _slot_types = ['string','robotnik_msgs/LaserStatus','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       robot_mode,laser_status,is_charging,manual_release,bumper_override

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SafetyModuleStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.robot_mode is None:
        self.robot_mode = ''
      if self.laser_status is None:
        self.laser_status = robotnik_msgs.msg.LaserStatus()
      if self.is_charging is None:
        self.is_charging = False
      if self.manual_release is None:
        self.manual_release = False
      if self.bumper_override is None:
        self.bumper_override = False
    else:
      self.robot_mode = ''
      self.laser_status = robotnik_msgs.msg.LaserStatus()
      self.is_charging = False
      self.manual_release = False
      self.bumper_override = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.robot_mode
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.laser_status.mode.mode
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_5B().pack(_x.laser_status.laser_ok, _x.laser_status.free_warning, _x.is_charging, _x.manual_release, _x.bumper_override))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.laser_status is None:
        self.laser_status = robotnik_msgs.msg.LaserStatus()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.robot_mode = str[start:end].decode('utf-8')
      else:
        self.robot_mode = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.laser_status.mode.mode = str[start:end].decode('utf-8')
      else:
        self.laser_status.mode.mode = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.laser_status.laser_ok, _x.laser_status.free_warning, _x.is_charging, _x.manual_release, _x.bumper_override,) = _get_struct_5B().unpack(str[start:end])
      self.laser_status.laser_ok = bool(self.laser_status.laser_ok)
      self.laser_status.free_warning = bool(self.laser_status.free_warning)
      self.is_charging = bool(self.is_charging)
      self.manual_release = bool(self.manual_release)
      self.bumper_override = bool(self.bumper_override)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.robot_mode
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.laser_status.mode.mode
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_5B().pack(_x.laser_status.laser_ok, _x.laser_status.free_warning, _x.is_charging, _x.manual_release, _x.bumper_override))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.laser_status is None:
        self.laser_status = robotnik_msgs.msg.LaserStatus()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.robot_mode = str[start:end].decode('utf-8')
      else:
        self.robot_mode = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.laser_status.mode.mode = str[start:end].decode('utf-8')
      else:
        self.laser_status.mode.mode = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.laser_status.laser_ok, _x.laser_status.free_warning, _x.is_charging, _x.manual_release, _x.bumper_override,) = _get_struct_5B().unpack(str[start:end])
      self.laser_status.laser_ok = bool(self.laser_status.laser_ok)
      self.laser_status.free_warning = bool(self.laser_status.free_warning)
      self.is_charging = bool(self.is_charging)
      self.manual_release = bool(self.manual_release)
      self.bumper_override = bool(self.bumper_override)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_5B = None
def _get_struct_5B():
    global _struct_5B
    if _struct_5B is None:
        _struct_5B = struct.Struct("<5B")
    return _struct_5B
